<?php
error_reporting(E_ALL & ~E_NOTICE);
?>

<?php


//#########################################################################################
// ADDRESSCHECK SECTION
//#########################################################################################


//**************************************************************
// Verify Addres Button Functions
//**************************************************************
if ( isset($_REQUEST['Verify']) )
{

	// Set the appropriate URL for the FLAT WSDL
	// $wsdl = "https://addresscheck.melissadata.net/v2/SOAP/Service.wsdl";
	$wsdl = ".\AddService.wsdl";


	try {
		// Throw an error if the WSDL is invalid
		if(!@file_get_contents($wsdl)) {
			throw new SoapFault('Server', 'No WSDL found at ' . $wsdl);
		}

		$CustomerID = $_POST['CustomerID'];
		$Address1 = $_POST['Address1'];
		$Address2 = $_POST['Address2'];
		$Company = $_POST['Company'];
		$Suite = $_POST['Suite'];
		$City = $_POST['City'];
		$State = $_POST['State'];
		$Zip = $_POST['Zip'];
		$Plus4 = $_POST['Plus4'];
		$Urbanization = $_POST['Urbanization'];
		$Country = $_POST['Country'];
        $AddressKey = $_POST['AddressKey'];
        $LastName = $_POST['LastName'];


		//Create the Soap Client
		$soap = new soapclient($wsdl);

		$parameters->Request->CustomerID=$CustomerID;
		$parameters->Request->TransmissionReference="Testing PHP SOAP Sample for AddressCheck";

		$Record[0] = array(
			'Company' => $Company,
			'AddressLine1' => $Address1,
			'AddressLine2' => $Address2,
			'City' => $City,
			'Suite' => $Suite,
			'State' => $State,
			'Zip' => $Zip,
			'Plus4' => $Plus4,
			'Urbanization' => $Urbanization,
			'Country' => $Country,
			'LastName' => $LastName
		);

		// Insert Records into the Record Array
		$RecordArray[0] = $Record[0];

		// Insert the Record Array into the Record stdClass
		$parameters->Request->Record=$RecordArray;

		// Call the doAddressCheck Method
		$result = $soap->doAddressCheck($parameters);


        $AddressKey = $result->doAddressCheckResult->Record->Address->AddressKey;

        include('melissa_form.php');

        // Handle the Outputs from the Results
		print_r("<br>" . "<b>Transmission Reference</b> - " . $result->doAddressCheckResult->TransmissionReference);


		printGlobalResults($result, "AddressCheck");

		print_r("<br> <br>" . "<b>Record</b> - " . $result->doAddressCheckResult->Record->RecordID);


		printRecordResults($result);

		print_r("<br>" . "<b>Company</b> - " . $result->doAddressCheckResult->Record->Address->Company);
		print_r("<br>" . "<b>Address Line 1</b> - " . $result->doAddressCheckResult->Record->Address->Address1);
		print_r("<br>" . "<b>Address Line 2</b> - " . $result->doAddressCheckResult->Record->Address->Address2);
		print_r("<br>" . "<b>Private Mailbox</b> - " . $result->doAddressCheckResult->Record->Address->PrivateMailBox);
		print_r("<br>" . "<b>Suite</b> - " . $result->doAddressCheckResult->Record->Address->Suite);
		print_r("<br>" . "<b>City</b> - " . $result->doAddressCheckResult->Record->Address->City->Name);
		print_r("<br>" . "<b>State</b> - " . $result->doAddressCheckResult->Record->Address->State->Abbreviation);
		print_r("<br>" . "<b>Zip</b> - " . $result->doAddressCheckResult->Record->Address->Zip);
		print_r("<br>" . "<b>Plus4</b> - " . $result->doAddressCheckResult->Record->Address->Plus4);
		print_r("<br>" . "<b>Urbanization</b> - " . $result->doAddressCheckResult->Record->Address->Urbanization->Name);
		print_r("<br>" . "<b>Carrier Route</b> - " . $result->doAddressCheckResult->Record->Address->CarrierRoute);
		print_r("<br>" . "<b>Delivery Point Code</b> - " . $result->doAddressCheckResult->Record->Address->DeliveryPointCode);
		print_r("<br>" . "<b>Delivery Point Check Digit</b> - " . $result->doAddressCheckResult->Record->Address->DeliveryPointCheckDigit);
		print_r("<br>" . "<b>Zip Type</b> - " . $result->doAddressCheckResult->Record->Address->Type->Zip->Description);
		print_r("<br>" . "<b>Address Description</b> - " . $result->doAddressCheckResult->Record->Address->Type->Address->Description);
		print_r("<br>" . "<b>Country</b> - " . $result->doAddressCheckResult->Record->Address->Country->Name);
		print_r("<br>" . "<b>Address Key</b> - " . $result->doAddressCheckResult->Record->Address->AddressKey);
		print_r("<br><br><br><br><br>");



	} catch(SoapFault $fault) {

		print_r("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})");
	}

}



//**************************************************************
// Clear Button Functions
//**************************************************************

if ( isset($_REQUEST['Clear']) )
{
	$CustomerID = "";
	$Address1 = "";
	$Address2 = "";
	$Company = "";
	$Suite = "";
	$City = "";
	$State = "";
	$Zip = "";
	$Plus4 = "";
	$Urbanization = "";
	$Country = "";
	$LastName = "";

	include('melissa_form.php');
}



//**************************************************************
// Insert Sample Address to the Form
//**************************************************************

if ( isset($_REQUEST['Insert']) )
{
	$CustomerID = $_POST['CustomerID'];

	$Company = "Melissa Data";
	$Address1 = "22382 Avenida Empresa";
	$City = "Rancho Santa Margarita";
	$State = "CA";
	$Zip = "92688";
	include('melissa_form.php');
}


//**************************************************************
// Function to Print Global Results
//**************************************************************

function printGlobalResults($result, $service)
{


    if($service == "AddressCheck")
    {
        $res = $result->doAddressCheckResult->Results;
    }
    if($service == "GeoCoder")
    {
        $res = $result->doGeoCodeResult->Results;
    }
	print_r("<br>" . "<b>Global Result Codes</b> - " . $res);
	print_r("<br>" . "<b>Global Result Description</b> - ");


	if($res == "SE01")
	{
		print_r("Web Service Internal Error");
	}
	elseif($res == "GE01")
	{
		print_r("Empty XML Request Structure");
	}
	elseif($res == "GE02")
	{
		print_r("Empty XML Request Record Structure");
	}
	elseif($res == "GE03")
	{
		print_r("Requested Records Exceed the Maximum Amount");
	}
	elseif($res == "GE04")
	{
		print_r("Customer ID Empty");
	}
	elseif($res == "GE05")
	{
		print_r("Customer ID Invalid");
	}
	elseif($res == "GE06")
	{
		print_r("Customer ID Disabled");
	}
	elseif($res == "GE07")
	{
		print_r("XML request Invalid");
	}
    else
    {
        print_r("No Error");
    }

}


//**************************************************************
// Function to Print Records Results
//**************************************************************

function printRecordResults($result)
{
	$res = $result->doAddressCheckResult->Record->Results;
	print_r("<br>" . "<b>Record Result Codes</b> - " . $res);
	print_r("<br>" . "<b>Record Result Description</b> - ");

	$ResultList = split(",", $res);

    foreach($ResultList as $value)
	{

	   if($value == "AS01")
	   {
	        print_r("Address Matched to Postal Database.");
	   }
	   elseif($value == "AS01")
	   {
			print_r("Address Matched to Postal Database.");
	   }
	   elseif($value == "AS02")
	   {
			print_r("Address Matched to Non-Postal Database.");
	   }
	   elseif($value == "AS09")
	   {
			print_r("Foreign Postal Code Detected");
	   }
	   elseif($value == "AS10")
	   {
			print_r("Address Matched to CMRA.");
	   }
	   elseif($value == "AS11")
	   {
			print_r("Address Vacant.");
	   }
	   elseif($value == "AS12")
	   {
			print_r("Address Coded at the DPV Level.");
	   }
	   elseif($value == "AS13")
	   {
			print_r("Address Updated by LACS.");
	   }
	   elseif($value == "AS14")
	   {
			print_r("Address Updated by Suite Link.");
	   }
	   elseif($value == "AS15")
	   {
			print_r("Address Updated by Suite Finder.");
	   }


	   elseif($value == "AE01")
	   {
			print_r("Zip Code Error.");
	   }
	   elseif($value == "AE02")
	   {
			print_r("Unknown Street.");
	   }
	   elseif($value == "AE03")
	   {
			print_r("Component Error.");
	   }
	   elseif($value == "AE04")
	   {
			print_r("Non-Deliverable Address.");
	   }
	   elseif($value == "AE05")
	   {
			print_r("Address Matched to Multiple Records.");
	   }
	   elseif($value == "AE06")
	   {
			print_r("Address Matched to Early Warning System.");
	   }
	   elseif($value == "AE07")
	   {
			print_r("Empty Address Input.");
	   }
	   elseif($value == "AE08")
	   {
			print_r("Suite Range Error.");
	   }
	   elseif($value == "AE09")
	   {
			print_r("Suite Range Missing.");
	   }
	   elseif($value == "AE10")
	   {
	   		print_r("Primary Range Error.");
	   }
	   elseif($value == "AE11")
	   {
			print_r("Primary Range Missing.");
	   }
	   elseif($value == "AE12")
	   {
			print_r("Box Number Error From PO Box or RR.");
	   }
	   elseif($value == "AE13")
	   {
			print_r("PO Box Number Missing From PO Box or RR.");
	   }
	   elseif($value == "AE14")
	   {
			print_r("Input Address Matched to CMRA but Secondary Number Not Present.");
	   }

	   print_r("  ");

	}
}


//#########################################################################################
// GEOCODER SECTION
//#########################################################################################


//**************************************************************
// GeoCoder Button Functions
//**************************************************************
if ( isset($_REQUEST['VerifyGeo']) )
{

    // Set the appropriate URL for the FLAT WSDL
	// $wsdl = "https://geocoder.melissadata.net/v2/SOAP/Service.wsdl";
	$wsdl = ".\GeoService.wsdl";


	try {
		// Throw an error if the WSDL is invalid
		if(!@file_get_contents($wsdl)) {
			throw new SoapFault('Server', 'No WSDL found at ' . $wsdl);
		}

		$CustomerID = $_POST['CustomerID'];
		$AddressKey = $_POST['AddressKey'];


		//Create the Soap Client
		$soap = new soapclient($wsdl);

		$parametersgeo->Request->CustomerID=$CustomerID;
		$parametersgeo->Request->TransmissionReference="Testing PHP SOAP Sample for GeoCode";

		$Record[0] = array(
			'AddressKey' => $AddressKey,
		);

		// Insert Records into the Record Array
		$RecordArray[0] = $Record[0];

		// Insert the Record Array into the Record stdClass
		$parametersgeo->Request->Record=$RecordArray;

		// Call the doAddressCheck Method
		$result = $soap->doGeoCode($parametersgeo);

		include('melissa_form.php');

		// Handle the Outputs from the Results
		print_r("<br>" . "<b>Transmission Reference</b> - " . $result->doGeoCodeResult->TransmissionReference);

		printGlobalResults($result, "GeoCoder");

		print_r("<br> <br>" . "<b>Record</b> - " . $result->doGeoCodeResult->Record->RecordID);


		printRecordResultsGeo($result);
		print_r("<br>" . "<b>County Name</b> - " . $result->doGeoCodeResult->Record->Address->County->Name);
		print_r("<br>" . "<b>County FIPS</b> - " . $result->doGeoCodeResult->Record->Address->County->Fips);
		print_r("<br>" . "<b>Latitude</b> - " . $result->doGeoCodeResult->Record->Address->Latitude);
		print_r("<br>" . "<b>Longitude</b> - " . $result->doGeoCodeResult->Record->Address->Longitude);
		print_r("<br>" . "<b>Place Code</b> - " . $result->doGeoCodeResult->Record->Address->Place->Code);
		print_r("<br>" . "<b>Place Name</b> - " . $result->doGeoCodeResult->Record->Address->Place->Name);
		print_r("<br>" . "<b>Time Zone Name</b> - " . $result->doGeoCodeResult->Record->Address->TimeZone->Name);
		print_r("<br>" . "<b>Time Zone Code</b> - " . $result->doGeoCodeResult->Record->Address->TimeZone->Code);
		print_r("<br>" . "<b>CBSA Code</b> - " . $result->doGeoCodeResult->Record->Address->CBSA->Code);
		print_r("<br>" . "<b>CBSA Title</b> - " . $result->doGeoCodeResult->Record->Address->CBSA->Title);
		print_r("<br>" . "<b>CBSA Level</b> - " . $result->doGeoCodeResult->Record->Address->CBSA->Level);
		print_r("<br>" . "<b>CBSA Division Code</b> - " . $result->doGeoCodeResult->Record->Address->CBSA->CBSADivisionCode);
		print_r("<br>" . "<b>CBSA Division Title</b> - " . $result->doGeoCodeResult->Record->Address->CBSA->CBSADivisionTitle);
		print_r("<br>" . "<b>CBSA Division Level</b> - " . $result->doGeoCodeResult->Record->Address->CBSA->CBSADivisionLevel);
		print_r("<br>" . "<b>Census Block</b> - " . $result->doGeoCodeResult->Record->Address->Census->Block);
		print_r("<br>" . "<b>Census Tract</b> - " . $result->doGeoCodeResult->Record->Address->Census->Tract);
		print_r("<br><br><br><br><br>");



	} catch(SoapFault $fault) {

		print_r("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})");
	}

}


//**************************************************************
// Clear Button Functions
//**************************************************************

if ( isset($_REQUEST['ClearGeo']) )
{
	$CustomerID = "";
	$AddressKey = "";

	include('melissa_form.php');
}




//**************************************************************
// Function to Print Records Results
//**************************************************************

function printRecordResultsGeo($result)
{
	$res = $result->doGeoCodeResult->Record->Results;
	print_r("<br>" . "<b>Record Result Codes</b> - " . $res);
	print_r("<br>" . "<b>Record Result Description</b> - ");

	$ResultList = split(",", $res);

    foreach($ResultList as $value)
	{

	   if($value == "GS01")
	   {
	        print_r("Geocoded to Zip+4 or the full 6-digit Postal Code Centroid.");
	   }
	   elseif($value == "GS02")
	   {
			print_r("Geocoded to Zip+2 Centroid.");
	   }
	   elseif($value == "GS03")
	   {
			print_r("Geocoded to 5 digit (U.S.) or 3 digit (Canada) zip code Centroid.");
	   }
	   elseif($value == "GS05")
	   {
			print_r("Geocoded to Rooftop level.");
	   }
	   elseif($value == "GS06")
	   {
			print_r("Geocoded to Interpolated Rooftop level.");
	   }

	   elseif($value == "GE01")
	   {
			print_r("Zip Code Error.");
	   }
	   elseif($value == "DE")
	   {
			print_r("Error In Data Field.");
	   }


	   print_r("  ");
	}
}

?>
